// Tulsa Sample App.h : main header file for the TULSA SAMPLE APP application
//

#ifndef _TULSA_SAMPLE_APP_H_
#define _TULSA_SAMPLE_APP_H_

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"  
#include <IStbTulsaCtl.h>
#include <IStbTDebug.h>   
#include "ddraw.h"
#include "dvp.h"
#include <ISTBTDDExt.h>

typedef enum {
	UNITS_TIME = 0,
	UNITS_POS,
	UNITS_FRAME
} STATUS_UNITS, *PSTATUS_UNITS;

#define NUM_CHANS	(NUM_AV_CHANNELS)	// Number of channels per board							
										// Macro to calc logical channel from
										//  physical card ID and board channel(ie. port)
#define LOG_CHAN(Card, Chan)	((Chan) + (Card)*NUM_CHANS)

extern STATUS_UNITS StatusUnits;		// Current status units
extern BOOL bAutoView;					// TRUE if app should auto cycle thru each card dialog page

enum {
	RGB_PROC_GUIDS = 0,
	YUV_PROC_GUIDS,
	NUM_DDE_GUID_TYPES
};

typedef struct {
	GUID RGBProcGuids[MAX_STB_TULSA_CARDS];
	GUID YUVProcGuids[MAX_STB_TULSA_CARDS];
} DDE_GUIDS;

extern GUID tcGuids[MAX_STB_TULSA_CARDS];
extern DDE_GUIDS ddeGuids;


BOOL CALLBACK SDDeEnumCallback(GUID FAR *lpGUID, LPWSTR lpDriverDescription, LPWSTR lpDriverName, LPVOID lpContext);
BOOL CALLBACK STCEnumCallback(GUID FAR *lpGUID, LPWSTR lpDriverDescription, LPWSTR lpDriverName, LPVOID lpContext);
BOOL HrSUCCEEDED(HRESULT hr);

#define WM_UPDATE_CARD_STATUS	(WM_USER + 1)



/////////////////////////////////////////////////////////////////////////////
// CTulsaSampleAppApp:
// See Tulsa Sample App.cpp for the implementation of this class
//
class CTulsaSampleAppApp : public CWinApp
{
public:
	CTulsaSampleAppApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTulsaSampleAppApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CTulsaSampleAppApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////
//  CRefCount
//////////////////////////////////////////////////////////////////////////
class CRefCount 
{
public:
        CRefCount() : m_cRef(1)  {};

        UINT AddRef()  {return(++m_cRef);}
        UINT Release() {return(m_cRef ? --m_cRef : m_cRef);}
        UINT GetRef()  {return(  m_cRef);}

private:
        UINT m_cRef;

} ;

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
#define QUERY_MY_INTERFACE(iid, i)	\
   if (IsEqualIID(riid, iid))\
	{							\
        *ppv = (i *)this;		\
        AddRef();				\
        return NOERROR;			\
    }							\
	else						\
		return E_NOINTERFACE;



#endif
